#ifndef OSHANDLES_H
#define OSHANDLES_H

/***********************************************************************************************/
/*** This file has to be .h (C not C++) because if it is hpp, then C-code can't include this ***/
/***********************************************************************************************/

#include "./FreeRTOS/FreeRTOS.h"	// Includes for RTOS & Other services provided by it:
#include "./FreeRTOS/task.h"
#include "./FreeRTOS/queue.h"
#include "./FreeRTOS/semphr.h"
#include "./FreeRTOS/timers.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "ctype.h"

// A pointer to OSHANDLES is all that is needed for any file/task to access
// Semaphores, task handles, queue handles etc...
// Pointer can be passed to task as pvParameter
typedef struct
{
	struct
	{
		// TODO 1.  Add a Queue Handle for a "song name"
		xQueueHandle ctrlToSD; // used to start the opening and sending of songNames from SD task
		xQueueHandle trackCTRL; // NEXT, PREVIOUS, STOP control items from buttonMonitor --> mp3 task
		xQueueHandle mp3CTRL; // TSOP decoder task sends items to main control task (butonMonitor)
		xQueueHandle songNameQueue; // queue used for sending and receiving items between SD and mp3 tasks
	}queue;

	struct
	{
		xTaskHandle userInterface;
		xTaskHandle mp3;
		xTaskHandle SD_card;
		xTaskHandle buttonMonitor;
		xTaskHandle tsop1236Task;
	}task;

	struct
	{
		xSemaphoreHandle SPI;
		xSemaphoreHandle MP3;
	}lock;

}OSHANDLES;

#endif /* osHandles */
